/**
 * This plugin is used to create a mosaic layout.
 *
 * @author Rob Gietema
 * @version 0.1
 * @licstart  The following is the entire license notice for the JavaScript
 *            code in this page.
 *
 * Copyright (C) 2010 Plone Foundation
 *
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the Free
 * Software Foundation; either version 2 of the License.
 *
 * This program is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for
 * more details.
 *
 * You should have received a copy of the GNU General Public License along with
 * this program; if not, write to the Free Software Foundation, Inc., 51
 * Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
 *
 * @licend  The above is the entire license notice for the JavaScript code in
 *          this page.
 */

/**
 * This plugin is used to create a mosaic toolbar.
 *
 * @author Rob Gietema
 * @version 0.1
 * @licstart  The following is the entire license notice for the JavaScript
 *            code in this page.
 *
 * Copyright (C) 2010 Plone Foundation
 *
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the Free
 * Software Foundation; either version 2 of the License.
 *
 * This program is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for
 * more details.
 *
 * You should have received a copy of the GNU General Public License along with
 * this program; if not, write to the Free Software Foundation, Inc., 51
 * Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
 *
 * @licend  The above is the entire license notice for the JavaScript code in
 *          this page.
 */

/**
 * This plugin is used to register and execute actions.
 *
 * @author Rob Gietema
 * @version 0.1
 * @licstart  The following is the entire license notice for the JavaScript
 *            code in this page.
 *
 * Copyright (C) 2010 Plone Foundation
 *
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the Free
 * Software Foundation; either version 2 of the License.
 *
 * This program is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for
 * more details.
 *
 * You should have received a copy of the GNU General Public License along with
 * this program; if not, write to the Free Software Foundation, Inc., 51
 * Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
 *
 * @licend  The above is the entire license notice for the JavaScript code in
 *          this page.
 */

/**
 * This plugin is used to define the mosaic namespace
 *
 * @author Rob Gietema
 * @licstart  The following is the entire license notice for the JavaScript
 *            code in this page.
 *
 * Copyright (C) 2010 Plone Foundation
 *
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the Free
 * Software Foundation; either version 2 of the License.
 *
 * This program is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for
 * more details.
 *
 * You should have received a copy of the GNU General Public License along with
 * this program; if not, write to the Free Software Foundation, Inc., 51
 * Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
 *
 * @licend  The above is the entire license notice for the JavaScript code in
 *          this page.
 * @version 0.1
 */

/**
 * This plugin is used to set an element to be editable.
 *
 * @author Rob Gietema
 * @version 0.1
 * @licstart  The following is the entire license notice for the JavaScript
 *            code in this page.
 *
 * Copyright (C) 2011 Plone Foundation
 *
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the Free
 * Software Foundation; either version 2 of the License.
 *
 * This program is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for
 * more details.
 *
 * You should have received a copy of the GNU General Public License along with
 * this program; if not, write to the Free Software Foundation, Inc., 51
 * Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
 *
 * @licend  The above is the entire license notice for the JavaScript code in
 *          this page.
 */

/**
 * This plugin is used to display an overlay
 *
 * @author Rob Gietema
 * @licstart  The following is the entire license notice for the JavaScript
 *            code in this page.
 *
 * Copyright (C) 2010 Plone Foundation
 *
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the Free
 * Software Foundation; either version 2 of the License.
 *
 * This program is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for
 * more details.
 *
 * You should have received a copy of the GNU General Public License along with
 * this program; if not, write to the Free Software Foundation, Inc., 51
 * Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
 *
 * @licend  The above is the entire license notice for the JavaScript code in
 *          this page.
 * @version 0.1
 */

/**
 * This plugin is used to create the mosaic undo stack, and enable
 * undo/redo actions. The JS defines two classes, one for internal use
 * ($.mosaic.undo.Stack) and the public one $.mosaic.unto.UndoManager. The
 * latter needs to be initialized (form the mosaic core), using:
 *  - stack size (max undo history)
 *  - reference to a handler that is called with the state as argument on undo/redo
 *  - current state (optional)
 *
 * The state can be anyting, but a feasible use is a DOM snippet as
 * state, that can be re-applied to an element on undo/redo.  Check
 * out plone.app.mosaic/plone/app/mosaic/tests/javascipts/test_undo.html
 * for an example wiring.
 *
 * Currently for mosaic the 'public' methods of the module are 'init',
 * 'undo', 'redo', 'hasInitial' and 'snapshot'. The undo manager
 * always needs an intial state (to be able to redo the undo...). A
 * state can be added with the jQuery.mosaic.undo.snapshot
 * method. Always take the snapshot AFTER the change in the DOM.
 *
 * @author D.A.Dokter
 * @version 0.1
 * @licstart  The following is the entire license notice for the JavaScript
 *            code in this page.
 *
 * Copyright (C) 2010 Plone Foundation
 *
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the Free
 * Software Foundation; either version 2 of the License.
 *
 * This program is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for
 * more details.
 *
 * You should have received a copy of the GNU General Public License along with
 * this program; if not, write to the Free Software Foundation, Inc., 51
 * Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
 *
 * @licend  The above is the entire license notice for the JavaScript code in
 *          this page.
 */

/**
 * This plugin is used to upload files and images.
 *
 * @author Rob Gietema
 * @version 0.1
 * @licstart  The following is the entire license notice for the JavaScript
 *            code in this page.
 *
 * Copyright (C) 2010 Plone Foundation
 *
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the Free
 * Software Foundation; either version 2 of the License.
 *
 * This program is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for
 * more details.
 *
 * You should have received a copy of the GNU General Public License along with
 * this program; if not, write to the Free Software Foundation, Inc., 51
 * Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
 *
 * @licend  The above is the entire license notice for the JavaScript code in
 *          this page.
 */

define("mosaic.layout",["jquery","mockup-patterns-modal"],function(e,i){"use strict";function a(e){switch(e){case 25:return"mosaic-width-quarter";case 33:return"mosaic-width-third";case 50:return"mosaic-width-half";case 66:case 67:return"mosaic-width-two-thirds";case 75:return"mosaic-width-three-quarters";case 100:return"mosaic-width-full"}return"mosaic-width-full"}function t(e){switch(e){case 0:return"mosaic-position-leftmost";case 25:return"mosaic-position-quarter";case 33:return"mosaic-position-third";case 50:return"mosaic-position-half";case 66:case 67:return"mosaic-position-two-thirds";case 75:return"mosaic-position-three-quarters"}return"mosaic-position-leftmost"}"undefined"==typeof e.mosaic&&(e.mosaic={}),e.mosaic.layout={widthClasses:["mosaic-width-quarter","mosaic-width-third","mosaic-width-half","mosaic-width-two-thirds","mosaic-width-three-quarters","mosaic-width-full"],positionClasses:["mosaic-position-leftmost","mosaic-position-quarter","mosaic-position-third","mosaic-position-half","mosaic-position-two-thirds","mosaic-position-three-quarters"]},e.fn.mosaicLayout=function(){var s=function(i){if(27===i.keyCode){var a=e(".mosaic-original-tile",e.mosaic.document);a.length>0?a.each(function(){e(this).addClass("mosaic-drag-cancel"),e(document).trigger(e(this).hasClass("mosaic-helper-tile-new")?"mousedown":"mouseup")}):(e(".mosaic-selected-tile",e.mosaic.document).removeClass("mosaic-selected-tile").children(".mosaic-tile-content").blur(),e.mosaic.options.toolbar.trigger("selectedtilechange"),e.mosaic.options.panels.mosaicSetResizeHandleLocation()),e(".mosaic-resize-handle-helper",e.mosaic.document).each(function(){e(this).parents("[data-panel]").removeClass("mosaic-panel-resizing"),e(this).parent().removeClass("mosaic-row-resizing"),e(this).parent().children(".mosaic-resize-placeholder").remove(),e(this).remove()}),e.mosaic.overlay.app.hide()}};e(e.mosaic.document).bind("keydown",s);var o=function(i){var a;i.target?a=i.target:i.srcElement&&(a=i.srcElement),0===e(a).parents(".mosaic-tile").length&&0===e(a).parents(".mosaic-toolbar").length&&(e(".mosaic-selected-tile",e.mosaic.document).removeClass("mosaic-selected-tile").children(".mosaic-tile-content").blur(),e.mosaic.options.toolbar.trigger("selectedtilechange"),e.mosaic.options.panels.mosaicSetResizeHandleLocation());var t=e(".mosaic-helper-tile-new",e.mosaic.document);t.length>0&&t.each(function(){e(this).mosaicHandleDragEnd()})};e(e.mosaic.document).bind("mousedown",o);var c=function(i){e(".mosaic-helper-tile-new",e.mosaic.document).each(function(){var a=e(this).parent().offset();e(this).css("top",i.pageY+3-a.top),e(this).css("left",i.pageX+3-a.left)}),e(".mosaic-resize-handle-helper",e.mosaic.document).each(function(){var s,o,c=e(this),n=c.parent(),l=parseFloat(i.pageX-n.offset().left-4),r=l/c.data("row_width")*100,d=25,m=1e3;if(e([25,33,50,67,75]).each(function(){o=Math.abs(this-r),m>o&&(d=this,m=o)}),2===c.data("nr_of_columns"))c.data("column_sizes").split(" ")[0]!==d&&(n.children(".mosaic-resize-placeholder").each(function(i){0===i?e(this).removeClass(e.mosaic.layout.widthClasses.join(" ")).addClass(a(parseInt(d,10))):(e(this).removeClass(e.mosaic.layout.positionClasses.join(" ").replace(/position/g,"resize")).removeClass(e.mosaic.layout.widthClasses.join(" ")).addClass(a(parseInt(100-d,10))).addClass(t(parseInt(d,10)).replace("position","resize")),c.removeClass(e.mosaic.layout.positionClasses.join(" ").replace(/position/g,"resize")).addClass(t(parseInt(d,10)).replace("position","resize")))}),e(this).data("column_sizes",d+" "+(100-d)));else{var p=e(this).data("resize_handle_index");if(1===p){if(c.data("column_sizes").split(" ")[e(this).data("resize_handle_index")-1]!==d&&parseInt(d,10)<=50)switch(s=n.children(".mosaic-resize-placeholder"),s.removeClass(e.mosaic.layout.positionClasses.join(" ").replace(/position/g,"resize")).removeClass(e.mosaic.layout.widthClasses.join(" ")),c.removeClass(e.mosaic.layout.positionClasses.join(" ").replace(/position/g,"resize")).addClass(t(parseInt(d,10)).replace("position","resize")),parseInt(d,10)){case 25:e(s.get(0)).addClass(t(0).replace("position","resize")+" "+a(25)),e(s.get(1)).addClass(t(25).replace("position","resize")+" "+a(50)),e(s.get(2)).addClass(t(75).replace("position","resize")+" "+a(25)),c.data("column_sizes","25 50 25");break;case 33:e(s.get(0)).addClass(t(0).replace("position","resize")+" "+a(33)),e(s.get(1)).addClass(t(33).replace("position","resize")+" "+a(33)),e(s.get(2)).addClass(t(66).replace("position","resize")+" "+a(33)),c.data("column_sizes","33 33 33");break;case 50:e(s.get(0)).addClass(t(0).replace("position","resize")+" "+a(50)),e(s.get(1)).addClass(t(50).replace("position","resize")+" "+a(25)),e(s.get(2)).addClass(t(75).replace("position","resize")+" "+a(25)),c.data("column_sizes","50 25 25")}}else if(c.data("column_sizes").split(" ")[e(this).data("resize_handle_index")]!==100-d&&parseInt(d,10)>=50)switch(s=n.children(".mosaic-resize-placeholder"),s.removeClass(e.mosaic.layout.positionClasses.join(" ").replace(/position/g,"resize")).removeClass(e.mosaic.layout.widthClasses.join(" ")),c.removeClass(e.mosaic.layout.positionClasses.join(" ").replace(/position/g,"resize")).addClass(t(parseInt(d,10)).replace("position","resize")),parseInt(d,10)){case 50:e(s.get(0)).addClass(t(0).replace("position","resize")+" "+a(25)),e(s.get(1)).addClass(t(25).replace("position","resize")+" "+a(25)),e(s.get(2)).addClass(t(50).replace("position","resize")+" "+a(50)),c.data("column_sizes","25 25 50");break;case 66:case 67:e(s.get(0)).addClass(t(0).replace("position","resize")+" "+a(33)),e(s.get(1)).addClass(t(33).replace("position","resize")+" "+a(33)),e(s.get(2)).addClass(t(66).replace("position","resize")+" "+a(33)),c.data("column_sizes","33 33 33");break;case 75:e(s.get(0)).addClass(t(0).replace("position","resize")+" "+a(25)),e(s.get(1)).addClass(t(25).replace("position","resize")+" "+a(50)),e(s.get(2)).addClass(t(75).replace("position","resize")+" "+a(25)),c.data("column_sizes","25 50 25")}}})};e(e.mosaic.document).bind("mousemove",c),e(e.mosaic.document).bind("dragover",c);var n=function(){e(".mosaic-resize-handle-helper",e.mosaic.document).each(function(){var i=e(this).parents("[data-panel]"),s=e(this).data("column_sizes").split(" ");e(this).parent().children(".mosaic-grid-cell").each(function(i){for(var o=0,c=0;i>c;c+=1)o+=parseInt(s[c],10);e(this).removeClass(e.mosaic.layout.positionClasses.join(" ")).removeClass(e.mosaic.layout.widthClasses.join(" ")).addClass(t(o)+" "+a(parseInt(s[i],10)))}),i.removeClass("mosaic-panel-resizing"),e(this).parent().removeClass("mosaic-row-resizing"),e(this).parent().children(".mosaic-resize-placeholder").remove(),e(this).parent().mosaicSetResizeHandles(),i.mosaicSetResizeHandleLocation(),i.find(".mosaic-selected-tile").mosaicFocusTileContent(),e(this).remove()})};e(e.mosaic.document).bind("mouseup",n);var l=function(i){if(e(this).parents("[data-panel]").hasClass("mosaic-panel-dragging")&&(e(".mosaic-selected-divider",e.mosaic.document).removeClass("mosaic-selected-divider"),e(this).hasClass("mosaic-original-tile")===!1&&e(this).hasClass("mosaic-tile-align-left")===!1&&e(this).hasClass("mosaic-tile-align-right")===!1)){var a=e(this).mosaicGetDirection(i),t=e(this).children(".mosaic-divider-"+a);if("left"===a||"right"===a){var s=t.parent().parent().parent();s.children(".mosaic-grid-cell").length>1?(t.height(s.height()+5),t.css("top",s.offset().top-t.parent().offset().top-5)):(t.height(t.parent().height()+5),t.css("top",-5))}t.addClass("mosaic-selected-divider")}};e(e.mosaic.document).on("mousemove",".mosaic-tile",l),e(e.mosaic.document).on("dragover",".mosaic-tile",l),e(e.mosaic.document).on("click",".mosaic-tile",function(){e(this).mosaicSelectTile()}),e(e.mosaic.document).on("click",".mosaic-close-icon",function(){var i=e(this).parents(".mosaic-tile").mosaicGetTileConfig();if("app"===i.tile_type){var a=e(this).parents(".mosaic-tile").find(".tileUrl").html();e.mosaic.removeHeadTags(a);var t=a.split("?")[0];t=t.split("@@");var s=t[1].split("/");t=t[0]+"@@delete-tile/"+s[0]+"/"+s[1],t.match(/^\.\/.*/)&&(t=e.mosaic.options.context_url+t.replace(/^\./,"")),e.ajax({type:"GET",url:t,success:function(i){var a=e(i).find('[name="_authenticator"]').val();e.ajax({type:"POST",url:t,data:{"buttons.delete":"Delete",_authenticator:a},success:function(){}})}})}e.mosaic.options.panels.find(".mosaic-empty-row").remove();var o=e(this).parents(".mosaic-tile").parent().parent();e.mosaic.saveTileValueToForm(i.name,i),e(this).parent().remove(),e.mosaic.undo.snapshot(),o.mosaicCleanupRow(),e.mosaic.options.panels.mosaicAddEmptyRows(),e.mosaic.options.toolbar.trigger("selectedtilechange"),e.mosaic.options.toolbar.mosaicSetResizeHandleLocation()}),e(e.mosaic.document).on("click",".mosaic-info-icon",function(){var a=e(this).parents(".mosaic-tile").mosaicGetTileConfig();if("app"===a.tile_type){var t=e(this).parents(".mosaic-tile").find(".tileUrl").html();t=t.replace(/@@/,"@@edit-tile/"),t.match(/^\.\/.*/)&&(t=e.mosaic.options.context_url+t.replace(/^\./,"")),e(this).parents(".mosaic-tile").addClass("mosaic-edited-tile"),e.mosaic.overlay.app=new i(e(".mosaic-toolbar"),{ajaxUrl:t,loadLinksWithinModal:!0,buttons:'.formControls > input[type="submit"], .actionButtons > input[type="submit"]'}),e.mosaic.overlay.app.$el.off("after-render"),e.mosaic.overlay.app.on("after-render",function(){e('input[name*="cancel"]',e.mosaic.overlay.app.$modal).off("click").on("click",function(){e.mosaic.overlay.app.hide(),e.mosaic.overlay.app=null,e(".mosaic-edited-tile",e.mosaic.document).removeClass("mosaic-edited-tile")})}),e.mosaic.overlay.app.show(),e.mosaic.overlay.app.$el.off("formActionSuccess"),e.mosaic.overlay.app.on("formActionSuccess",function(i,a,t,s){var o=s.getResponseHeader("X-Tile-Url"),c=e.mosaic.getDomTreeFromHtml(a);o&&(e.mosaic.removeHeadTags(o),e.mosaic.addHeadTags(o,c),e(".mosaic-edited-tile .mosaic-tile-content",e.mosaic.document).html('<p class="hiddenStructure tileUrl">'+o.replace(/&/gim,"&amp;")+"</p>"+c.find(".temp_body_tag").html()),e.mosaic.overlay.app.hide(),e.mosaic.overlay.app=null),e(".mosaic-edited-tile",e.mosaic.document).removeClass("mosaic-edited-tile")})}else e.mosaic.overlay.open("field",a)});var r=this.length;return this.each(function(i){var a=e(this);if(a.find(".mosaic-tile").mosaicInitTile(),a.find(".mosaic-tile").mosaicAddDrag(),a.mosaicAddEmptyRows(),a.children(".mosaic-grid-row").mosaicSetResizeHandles(),i===r-1){var t=0,s=0;e.mosaic.options.panels.each(function(i){e(this).width()>t&&(t=e(this).width(),s=i)}),e.mosaic.options.panels.eq(s).find(".mosaic-tile:first").mosaicSelectTile()}})},e.fn.mosaicInitTile=function(){return this.each(function(){var i=e(this),a=(i.parents("[data-panel]"),e(this).mosaicGetTileConfig());a&&a.read_only&&e(this).addClass("mosaic-read-only-tile"),a&&e(this).hasClass("mosaic-read-only-tile")===!1&&("text"===a.tile_type&&a.rich_text||"app"===a.tile_type&&a.rich_text||"field"===a.tile_type&&a.read_only===!1&&("z3c.form.browser.text.TextWidget"===a.widget||"z3c.form.browser.text.TextFieldWidget"===a.widget||"z3c.form.browser.textarea.TextAreaWidget"===a.widget||"z3c.form.browser.textarea.TextAreaFieldWidget"===a.widget||"z3c.form.browser.textlines.TextLinesWidget"===a.widget||"z3c.form.browser.textlines.TextLinesFieldWidget"===a.widget||"plone.app.z3cform.widget.RichTextFieldWidget"===a.widget||"plone.app.z3cform.wysiwyg.widget.WysiwygWidget"===a.widget||"plone.app.z3cform.wysiwyg.widget.WysiwygFieldWidget"===a.widget||"plone.app.widgets.dx.RichTextWidget"===a.widget))&&e(this).children(".mosaic-tile-content").mosaicEditor(),e(this).prepend(e(e.mosaic.document.createElement("div")).addClass("mosaic-tile-outer-border").append(e(e.mosaic.document.createElement("div")).addClass("mosaic-tile-inner-border"))),a&&"field"===a.tile_type,a&&e(this).prepend(e(e.mosaic.document.createElement("div")).addClass("mosaic-tile-control mosaic-tile-label").append(e(e.mosaic.document.createElement("div")).addClass("mosaic-tile-label-content").html(a.label)).append(e(e.mosaic.document.createElement("div")).addClass("mosaic-tile-label-left"))),e(this).hasClass("movable")&&e.mosaic.options.can_change_layout&&e(this).prepend(e(e.mosaic.document.createElement("div")).addClass("mosaic-tile-control mosaic-drag-handle")),e(this).hasClass("removable")&&e.mosaic.options.can_change_layout&&e(this).prepend('<div class="mosaic-tile-control mosaic-close-icon"></div>'),a&&a.settings&&e(this).hasClass("mosaic-read-only-tile")===!1&&e(this).prepend(e(e.mosaic.document.createElement("div")).addClass("mosaic-tile-control mosaic-info-icon")),e(this).prepend(e(e.mosaic.document.createElement("div")).addClass("mosaic-divider mosaic-divider-top").append(e(e.mosaic.document.createElement("div")).addClass("mosaic-divider-dot"))),e(this).prepend(e(e.mosaic.document.createElement("div")).addClass("mosaic-divider mosaic-divider-bottom").append(e(e.mosaic.document.createElement("div")).addClass("mosaic-divider-dot"))),e(this).prepend(e(e.mosaic.document.createElement("div")).addClass("mosaic-divider mosaic-divider-right").append(e(e.mosaic.document.createElement("div")).addClass("mosaic-divider-dot"))),e(this).prepend(e(e.mosaic.document.createElement("div")).addClass("mosaic-divider mosaic-divider-left").append(e(e.mosaic.document.createElement("div")).addClass("mosaic-divider-dot")))})},e.fn.mosaicSelectTile=function(){return this.each(function(){e(this).hasClass("mosaic-selected-tile")===!1&&e(this).hasClass("mosaic-read-only-tile")===!1&&(e(".mosaic-selected-tile",e.mosaic.document).removeClass("mosaic-selected-tile").children(".mosaic-tile-content").blur(),e(this).addClass("mosaic-selected-tile"),e.mosaic.options.toolbar.trigger("selectedtilechange"),e.mosaic.options.panels.mosaicSetResizeHandleLocation(),e(this).mosaicFocusTileContent())})},e.fn.mosaicFocusTileContent=function(){return this.each(function(){var i=e(this).children(".mosaic-tile-content");i.focus()})},e.fn.mosaicAddMouseMoveEmptyRow=function(){return this.each(function(){e(this).mousemove(function(){var i=e(this).parents("[data-panel]");i.hasClass("mosaic-panel-dragging")&&(e(".mosaic-selected-divider",e.mosaic.document).removeClass("mosaic-selected-divider"),e(this).children("div").addClass("mosaic-selected-divider"))})})},e.fn.mosaicAddEmptyRows=function(){return this.each(function(){e(this).find(".mosaic-grid-row").each(function(i){e(this).children(".mosaic-grid-cell").length>1&&(0===i&&e(this).before(e(e.mosaic.document.createElement("div")).addClass("mosaic-grid-row mosaic-empty-row").append(e(e.mosaic.document.createElement("div")).addClass("mosaic-grid-cell mosaic-width-full mosaic-position-leftmost").append(e(e.mosaic.document.createElement("div")).append(e(e.mosaic.document.createElement("div")).addClass("mosaic-tile-outer-border").append(e(e.mosaic.document.createElement("div")).addClass("mosaic-divider-dot"))))).mosaicAddMouseMoveEmptyRow()),(0===e(this).nextAll(".mosaic-grid-row").length||e(this).next().children(".mosaic-grid-cell").length>1)&&e(this).after(e(e.mosaic.document.createElement("div")).addClass("mosaic-grid-row mosaic-empty-row").append(e(e.mosaic.document.createElement("div")).addClass("mosaic-grid-cell mosaic-width-full mosaic-position-leftmost").append(e(e.mosaic.document.createElement("div")).append(e(e.mosaic.document.createElement("div")).addClass("mosaic-tile-outer-border").append(e(e.mosaic.document.createElement("div")).addClass("mosaic-divider-dot"))))).mosaicAddMouseMoveEmptyRow()))})})},e.fn.mosaicGetWidthClass=function(){var i;for(i in e.mosaic.layout.widthClasses)if(e.mosaic.layout.widthClasses.hasOwnProperty(i)&&e(this).hasClass(e.mosaic.layout.widthClasses[i]))return e.mosaic.layout.widthClasses[i];for(i in e.mosaic.layout.widthClasses)if(e.mosaic.layout.widthClasses.hasOwnProperty(i)&&e(this).hasClass(e.mosaic.layout.widthClasses[i].replace("position","resize")))return e.mosaic.layout.widthClasses[i];return e.mosaic.layout.widthClasses[0]},e.fn.mosaicGetPositionClass=function(){var i;for(i in e.mosaic.layout.positionClasses)if(e(this).hasClass(e.mosaic.layout.positionClasses[i]))return e.mosaic.layout.positionClasses[i];for(i in e.mosaic.layout.positionClasses)if(e(this).hasClass(e.mosaic.layout.positionClasses[i].replace("position","resize")))return e.mosaic.layout.positionClasses[i];return e.mosaic.layout.positionClasses[0]},e.fn.mosaicAddDrag=function(){return this.each(function(){var i=e(this),a=function(i){var a=e(".mosaic-helper-tile",e.mosaic.document),t=a.parents("[data-panel]").offset();a.css("top",i.pageY+3-t.top),a.css("left",i.pageX+3-t.left)},t=function(){var i=e(".mosaic-helper-tile",e.mosaic.document);e(e.mosaic.document).unbind("mousemove",a).unbind("mouseup",t),i.mosaicHandleDragEnd(),i.remove()};return i.each(function(){i.find("div.mosaic-drag-handle").unbind("mousedown").bind("mousedown",function(i){var s=i.pageX,o=i.pageY,c=function(i){if(Math.max(Math.abs(s-i.pageX),Math.abs(o-i.pageY))>=1){e.mosaic.options.panels.addClass("mosaic-panel-dragging"),e(".mosaic-selected-tile",e.mosaic.document).removeClass("mosaic-selected-tile").children(".mosaic-tile-content").blur();var n=e(i.target).parents(".mosaic-tile"),l=n.clone(!0);n.addClass("mosaic-original-tile"),n.parents("[data-panel]").append(l),l.css({width:n.width(),position:"absolute",opacity:.5}).addClass("mosaic-helper-tile"),e(e.mosaic.document).mousemove(a),e(e.mosaic.document).mouseup(t),e(e.mosaic.document).unbind("mousemove",c)}};e(e.mosaic.document).bind("mousemove",c),e(e.mosaic.document).bind("mouseup",function(){e(e.mosaic.document).unbind("mousemove",c)})})})})},e.fn.mosaicHandleDragEnd=function(){e(this).parents("[data-panel]");e.mosaic.options.panels.removeClass("mosaic-panel-dragging mosaic-panel-dragging-new");var i=e(".mosaic-selected-divider",e.mosaic.document),a=i.parent(),t="";i.hasClass("mosaic-divider-top")&&(t="top"),i.hasClass("mosaic-divider-bottom")&&(t="bottom"),i.hasClass("mosaic-divider-left")&&(t="left"),i.hasClass("mosaic-divider-right")&&(t="right"),i.removeClass("mosaic-selected-divider");var s=e(".mosaic-helper-tile-new",e.mosaic.document).length>0,o=e(".mosaic-original-tile",e.mosaic.document);if(o.hasClass("mosaic-drag-cancel"))o.removeClass("mosaic-drag-cancel"),e.mosaic.options.panels.find(".mosaic-empty-row").remove(),s||o.removeClass("mosaic-original-tile").addClass("mosaic-new-tile");else if(a.hasClass("mosaic-empty-row"))a.removeClass("mosaic-empty-row").attr("class",o.parents(".mosaic-grid-row").first().attr("class")).unbind("mousemove"),a.children(".mosaic-grid-cell").children("div").remove(),a.children(".mosaic-grid-cell").append(o.clone(!0).removeClass("mosaic-original-tile mosaic-helper-tile mosaic-helper-tile-new mosaic-tile-align-right mosaic-tile-align-left").css({width:"",left:"",top:""}).mosaicAddDrag().addClass("mosaic-new-tile")),e(".mosaic-empty-row",e.mosaic.document).remove();else if(a.hasClass("mosaic-tile")===!1)e(".mosaic-empty-row",e.mosaic.document).remove(),s||o.removeClass("mosaic-original-tile").addClass("mosaic-new-tile");else if(4!==a.parent().parent().children(".mosaic-grid-cell").length||"left"!==t&&"right"!==t){if(e(".mosaic-empty-row",e.mosaic.document).remove(),"top"===t)a.before(o.clone(!0).removeClass("mosaic-original-tile mosaic-helper-tile mosaic-helper-tile-new mosaic-tile-align-right mosaic-tile-align-left").css({width:"",left:"",top:""}).mosaicAddDrag().addClass("mosaic-new-tile"));else if("bottom"===t)a.after(o.clone(!0).removeClass("mosaic-original-tile mosaic-helper-tile mosaic-helper-tile-new mosaic-tile-align-right mosaic-tile-align-left").css({width:"",left:"",top:""}).mosaicAddDrag().addClass("mosaic-new-tile"));else if("left"===t||"right"===t)if(1===a.parent().parent().children(".mosaic-grid-cell").length){var c=a.prevAll();c.length>0&&(a.parent().parent().before(e(e.mosaic.document.createElement("div")).addClass("mosaic-grid-row").append(e(e.mosaic.document.createElement("div")).addClass("mosaic-grid-cell mosaic-width-full mosaic-position-leftmost").append(e(c.get().reverse()).clone(!0).mosaicAddDrag()))),c.remove());var n=a.nextAll();n.length>0&&(a.parent().parent().after(e(e.mosaic.document.createElement("div")).addClass("mosaic-grid-row").append(e(e.mosaic.document.createElement("div")).addClass("mosaic-grid-cell mosaic-width-full mosaic-position-leftmost").append(n.clone(!0).mosaicAddDrag()))),n.remove()),a.parent().removeClass(e.mosaic.layout.widthClasses.join(" ")).removeClass(e.mosaic.layout.positionClasses.join(" ")).addClass("mosaic-width-half"),"left"===t?a.parent().addClass("mosaic-position-half").before(e(e.mosaic.document.createElement("div")).addClass("mosaic-grid-cell mosaic-width-half mosaic-position-leftmost").append(o.clone(!0).removeClass("mosaic-original-tile mosaic-helper-tile mosaic-helper-tile-new mosaic-tile-align-right mosaic-tile-align-left").css({width:"",left:"",top:""}).mosaicAddDrag().addClass("mosaic-new-tile"))):a.parent().addClass("mosaic-position-leftmost").after(e(e.mosaic.document.createElement("div")).addClass("mosaic-grid-cell mosaic-width-half mosaic-position-half").append(o.clone(!0).removeClass("mosaic-original-tile mosaic-helper-tile mosaic-helper-tile-new mosaic-tile-align-right mosaic-tile-align-left").css({width:"",left:"",top:""}).mosaicAddDrag().addClass("mosaic-new-tile"))),a.parent().parent().mosaicSetResizeHandles()}else"left"===t?a.parent().before(e(e.mosaic.document.createElement("div")).addClass("mosaic-grid-cell").append(o.clone(!0).removeClass("mosaic-original-tile mosaic-helper-tile mosaic-helper-tile-new mosaic-tile-align-right mosaic-tile-align-left").css({width:"",left:"",top:""}).mosaicAddDrag().addClass("mosaic-new-tile"))):a.parent().after(e(e.mosaic.document.createElement("div")).addClass("mosaic-grid-cell").append(o.clone(!0).removeClass("mosaic-original-tile mosaic-helper-tile mosaic-helper-tile-new mosaic-tile-align-right mosaic-tile-align-left").css({width:"",left:"",top:""}).mosaicAddDrag().addClass("mosaic-new-tile"))),a.parent().parent().mosaicSetColumnSizes(),a.parent().parent().mosaicSetResizeHandles()}else e(".mosaic-empty-row",e.mosaic.document).remove(),s||o.removeClass("mosaic-original-tile").addClass("mosaic-new-tile");var l=o.parent().parent();e(".mosaic-original-tile",e.mosaic.document).remove(),l.mosaicCleanupRow(),e.mosaic.options.panels.mosaicAddEmptyRows(),e(".mosaic-new-tile .mosaic-rich-text").each(function(){tinyMCE&&tinyMCE.get(e(this).attr("id"))&&(tinyMCE.get(e(this).attr("id")).remove(),e(this).mosaicEditor())}),s?e(".mosaic-new-tile",e.mosaic.document).removeClass("mosaic-new-tile").mosaicSelectTile():e(".mosaic-new-tile",e.mosaic.document).removeClass("mosaic-new-tile")},e.fn.mosaicSetColumnSizes=function(){return this.each(function(){var i=e(this).children(".mosaic-grid-cell").length;e(this).children(".mosaic-grid-cell").each(function(a){switch(e(this).removeClass(e.mosaic.layout.widthClasses.join(" ")).removeClass(e.mosaic.layout.positionClasses.join(" ")),i){case 1:e(this).addClass("mosaic-width-full mosaic-position-leftmost");break;case 2:switch(a){case 0:e(this).addClass("mosaic-width-half mosaic-position-leftmost");break;case 1:e(this).addClass("mosaic-width-half mosaic-position-half")}break;case 3:switch(a){case 0:e(this).addClass("mosaic-width-third mosaic-position-leftmost");break;case 1:e(this).addClass("mosaic-width-third mosaic-position-third");break;case 2:e(this).addClass("mosaic-width-third mosaic-position-two-thirds")}break;case 4:switch(a){case 0:e(this).addClass("mosaic-width-quarter mosaic-position-leftmost");break;case 1:e(this).addClass("mosaic-width-quarter mosaic-position-quarter");break;case 2:e(this).addClass("mosaic-width-quarter mosaic-position-half");break;case 3:e(this).addClass("mosaic-width-quarter mosaic-position-three-quarters")}}})})},e.fn.mosaicSetResizeHandles=function(){return this.each(function(){e(this).children(".mosaic-resize-handle").remove();var i=e(this).children(".mosaic-grid-cell").length;switch(i){case 2:e(this).append(e(e.mosaic.document.createElement("div")).addClass("mosaic-resize-handle mosaic-resize-handle-center mosaic-resize-handle-one "+e(e(this).children(".mosaic-grid-cell").get(1)).mosaicGetPositionClass().replace("position","resize")));break;case 3:e(this).append(e(e.mosaic.document.createElement("div")).addClass("mosaic-resize-handle mosaic-resize-handle-center mosaic-resize-handle-one "+e(e(this).children(".mosaic-grid-cell").get(1)).mosaicGetPositionClass().replace("position","resize"))),e(this).append(e(e.mosaic.document.createElement("div")).addClass("mosaic-resize-handle mosaic-resize-handle-center mosaic-resize-handle-two "+e(e(this).children(".mosaic-grid-cell").get(2)).mosaicGetPositionClass().replace("position","resize")))}e(this).children(".mosaic-resize-handle").mousedown(function(){var i=[];e(this).parent().children(".mosaic-grid-cell").each(function(){switch(e(this).mosaicGetWidthClass()){case"mosaic-width-half":i.push("50");break;case"mosaic-width-quarter":i.push("25");break;case"mosaic-width-third":i.push("33");break;case"mosaic-width-two-thirds":i.push("66");break;case"mosaic-width-three-quarters":i.push("75")}e(this).parent().append(e(e.mosaic.document.createElement("div")).addClass("mosaic-resize-placeholder "+e(this).mosaicGetWidthClass()+" "+e(this).mosaicGetPositionClass().replace("position","resize")).append(e(e.mosaic.document.createElement("div")).addClass("mosaic-resize-placeholder-inner-border")))});var a=1;return e(this).hasClass("mosaic-resize-handle-two")&&(a=2),e(this).parent().append(e(e.mosaic.document.createElement("div")).addClass("mosaic-resize-handle mosaic-resize-handle-helper").addClass(e(this).mosaicGetPositionClass().replace("position","resize")).data("row_width",e(this).parent().width()).data("nr_of_columns",e(this).parent().children(".mosaic-grid-cell").length).data("column_sizes",i.join(" ")).data("resize_handle_index",a)),e(this).parents("[data-panel]").addClass("mosaic-panel-resizing"),e(this).parent().addClass("mosaic-row-resizing"),e(".mosaic-selected-tile",e.mosaic.document).children(".mosaic-tile-content").blur(),!1})})},e.fn.mosaicCleanupRow=function(){return this.each(function(){var i=e(this);if(i.children(".mosaic-grid-cell").each(function(){0===e(this).children().length&&(e(this).remove(),i.mosaicSetColumnSizes())}),0===i.find(".mosaic-tile").length){var a=i;if(i.nextAll(".mosaic-grid-row").length>0)i=i.next(".mosaic-grid-row");else{if(!(i.prevAll(".mosaic-grid-row").length>0))return void i.remove();i=i.prev(".mosaic-grid-row")}a.remove()}i.prevAll(".mosaic-grid-row").length>0&&1===i.children(".mosaic-grid-cell").length&&1===i.prev().children(".mosaic-grid-cell").length&&(i.children(".mosaic-grid-cell").prepend(i.prev().children(".mosaic-grid-cell").children(".mosaic-tile").clone(!0).mosaicAddDrag()),i.prev().remove()),i.nextAll(".mosaic-grid-row").length>0&&1===i.children(".mosaic-grid-cell").length&&1===i.next().children(".mosaic-grid-cell").length&&(i.children(".mosaic-grid-cell").append(i.next().children(".mosaic-grid-cell").children(".mosaic-tile").clone(!0).mosaicAddDrag()),i.next().remove()),i.mosaicSetResizeHandles()})},e.fn.mosaicSetResizeHandleLocation=function(){var i=e(this);i.children(".mosaic-grid-row").each(function(){var i=e(this),a=i.children(".mosaic-grid-cell");(2===a.length||3===a.length)&&(i.children(".mosaic-resize-handle").removeClass("mosaic-resize-handle-left mosaic-resize-handle-center mosaic-resize-handle-right"),e(a.get(0)).children(".mosaic-tile").hasClass("mosaic-selected-tile")?(i.children(".mosaic-resize-handle-one").addClass("mosaic-resize-handle-left"),i.children(".mosaic-resize-handle-two").addClass("mosaic-resize-handle-center")):e(a.get(1)).children(".mosaic-tile").hasClass("mosaic-selected-tile")?(i.children(".mosaic-resize-handle-one").addClass("mosaic-resize-handle-right"),i.children(".mosaic-resize-handle-two").addClass("mosaic-resize-handle-left")):3===a.length&&e(a.get(2)).children(".mosaic-tile").hasClass("mosaic-selected-tile")?(i.children(".mosaic-resize-handle-one").addClass("mosaic-resize-handle-center"),i.children(".mosaic-resize-handle-two").addClass("mosaic-resize-handle-right")):(i.children(".mosaic-resize-handle-one").addClass("mosaic-resize-handle-center"),i.children(".mosaic-resize-handle-two").addClass("mosaic-resize-handle-center")))})},e.fn.mosaicGetTileConfig=function(){var i="",a=e(this).attr("class").split(" ");e(a).each(function(){var e=this.match(/^mosaic-(.*)-tile$/);null!==e&&"selected"!==e[1]&&"new"!==e[1]&&"read-only"!==e[1]&&"helper"!==e[1]&&"original"!==e[1]&&(i=e[1])});for(var t,s=0;s<e.mosaic.options.tiles.length;s+=1)for(var o=e.mosaic.options.tiles[s],c=0;c<o.tiles.length;c+=1)o.tiles[c].name===i&&(t=o.tiles[c]);return t},e.fn.mosaicGetDirection=function(i){var a=parseFloat(e(this).width()),t=parseFloat(e(this).height()),s=parseFloat(i.pageX-e(this).offset().left-a/2),o=parseFloat(i.pageY-e(this).offset().top-t/2),c=a/2,n=t/2;return 0>s?0>o?-1*c/(-1*n)>s/o?"top":"left":-1*c/n>s/o?"left":"bottom":0>o?1*c/(-1*n)>s/o?"right":"top":c/n>s/o?"bottom":"right"},e.mosaic.disableEditHtmlSource=function(){e(".mosaic-rich-text-textarea",e.mosaic.document).each(function(){var i,a;a=e(this).val(),i=e(this).parent(),i.html(a).mosaicEditor()})},e.mosaic.addAppTile=function(i,a){e.mosaic.overlay.app.hide(),e.ajax({type:"GET",url:a,success:function(t){t=e.mosaic.getDomTreeFromHtml(t),e.mosaic.addHeadTags(a,t),e.mosaic.addTile(i,'<p class="hiddenStructure tileUrl">'+a.replace(/&/gim,"&amp;")+"</p>"+t.find(".temp_body_tag").html())}})},e.mosaic.addAppTileHTML=function(i,a,t){var s;s=e.mosaic.getDomTreeFromHtml(a),e.mosaic.addHeadTags(t,s),e.mosaic.addTile(i,'<p class="hiddenStructure tileUrl">'+t.replace(/&/gim,"&amp;")+"</p>"+s.find(".temp_body_tag").html())},e.mosaic.editAppTile=function(i){e.mosaic.overlay.close(),window.parent.focus(),e.ajax({type:"GET",url:i,success:function(a){a=e.mosaic.getDomTreeFromHtml(a),e.mosaic.removeHeadTags(i),e.mosaic.addHeadTags(i,a),e(".mosaic-selected-tile .mosaic-tile-content",e.mosaic.document).html('<p class="hiddenStructure tileUrl">'+i.replace(/&/gim,"&amp;")+"</p>"+a.find(".temp_body_tag").html())}})},e.mosaic.addTile=function(i,a){e.mosaic.options.panels.addClass("mosaic-panel-dragging mosaic-panel-dragging-new"),e(e.mosaic.options.panels.get(0)).append(e(e.mosaic.document.createElement("div")).addClass("mosaic-grid-row").append(e(e.mosaic.document.createElement("div")).addClass("mosaic-grid-cell mosaic-width-half mosaic-position-leftmost").append(e(e.mosaic.document.createElement("div")).addClass("movable removable mosaic-tile mosaic-"+i+"-tile").append(e(e.mosaic.document.createElement("div")).addClass("mosaic-tile-content").html(a)).addClass("mosaic-helper-tile mosaic-helper-tile-new mosaic-original-tile"))));var t=e.mosaic.options.panels.find(".mosaic-helper-tile-new"),s=0;e.mosaic.options.panels.each(function(){e(this).width()>s&&(s=e(this).width())}),t.width(t.width()<s/4?s/4:t.width()),t.mosaicInitTile()},e.mosaic.getDefaultValue=function(i){var a,t,s,o;switch("IDublinCore-title"===i.name?(s='<h1 class="documentFirstHeading">',o="</h1>"):"IDublinCore-description"===i.name?(s='<p class="documentDescription">',o="</p>"):(s="<div>",o="</div>"),i.tile_type){case"field":switch(i.widget){case"z3c.form.browser.text.TextWidget":case"z3c.form.browser.text.TextFieldWidget":return s+e("#"+i.id,e.mosaic.document).find("input").attr("value")+o;case"z3c.form.browser.textarea.TextAreaWidget":case"z3c.form.browser.textarea.TextAreaFieldWidget":case"z3c.form.browser.textlines.TextLinesWidget":case"z3c.form.browser.textlines.TextLinesFieldWidget":for(var c=e("#"+i.id,e.mosaic.document).find("textarea").val().split("\n"),n="",l=0;l<c.length;l+=1)n+=c[l]+"<br/>";return s+n+o;case"plone.app.z3cform.widget.RichTextFieldWidget":case"plone.app.z3cform.wysiwyg.widget.WysiwygWidget":case"plone.app.z3cform.wysiwyg.widget.WysiwygFieldWidget":case"plone.app.widgets.dx.RichTextWidget":return a=e("#"+i.id).find("textarea").attr("id"),t=tinymce.get(a),t?t.getContent():"";
default:return'<div class="discreet">Placeholder for field:<br/><b>'+i.label+"</b></div>"}break;default:return i.default_value}},e.mosaic.saveTileValueToForm=function(i,a){var t,s,o,c;if(a&&"field"===a.tile_type&&a.read_only===!1&&("z3c.form.browser.text.TextWidget"===a.widget||"z3c.form.browser.text.TextFieldWidget"===a.widget||"z3c.form.browser.textarea.TextAreaWidget"===a.widget||"z3c.form.browser.textarea.TextAreaFieldWidget"===a.widget||"z3c.form.browser.textlines.TextLinesWidget"===a.widget||"z3c.form.browser.textlines.TextLinesFieldWidget"===a.widget||"plone.app.z3cform.widget.RichTextFieldWidget"===a.widget||"plone.app.z3cform.wysiwyg.widget.WysiwygWidget"===a.widget||"plone.app.z3cform.wysiwyg.widget.WysiwygFieldWidget"===a.widget||"plone.app.widgets.dx.RichTextWidget"===a.widget))switch(a.widget){case"z3c.form.browser.text.TextWidget":case"z3c.form.browser.text.TextFieldWidget":e("#"+a.id).find("input").attr("value",e(".mosaic-"+i+"-tile",e.mosaic.document).find(".mosaic-tile-content > *").text());break;case"z3c.form.browser.textarea.TextAreaWidget":case"z3c.form.browser.textarea.TextAreaFieldWidget":case"z3c.form.browser.textlines.TextLinesWidget":case"z3c.form.browser.textlines.TextLinesFieldWidget":o="",c="IDublinCore-description"===a.name?" ":"\n",e(".mosaic-"+i+"-tile",e.mosaic.document).find(".mosaic-tile-content > *").each(function(){o+=e(this).html().replace(/<br[^>]*>/gi,c).replace(/^\s+|\s+$/g,"")+c}),o=o.replace(/^\s+|\s+$/g,""),e("#"+a.id).find("textarea").val(o);break;case"plone.app.z3cform.widget.RichTextFieldWidget":case"plone.app.z3cform.wysiwyg.widget.WysiwygWidget":case"plone.app.z3cform.wysiwyg.widget.WysiwygFieldWidget":case"plone.app.widgets.dx.RichTextWidget":t=e(document.getElementById(a.id)).find("textarea").attr("id"),s=tinymce.get(t),s&&(s.setContent(e(".mosaic-"+i+"-tile",e.mosaic.document).find(".mosaic-tile-content").html()),e(document.getElementById(a.id)).find("textarea").val(s.getContent()))}},e.mosaic.getPageContent=function(){var i,a="",t="",s="";return e.mosaic.disableEditHtmlSource(),a+="  <body>\n",e("[data-panel]",e.mosaic.document).each(function(){s=e(this).attr("data-panel"),a+='    <div data-panel="'+s+'">\n',e(this).children(".mosaic-grid-row").each(function(){e(this).hasClass("mosaic-empty-row")===!1&&(t=e(this).attr("class"),a+='      <div class="'+t+'">\n',e(this).children(".mosaic-grid-cell").each(function(){a+='        <div class="'+e(this).attr("class")+'">\n',e(this).children(".mosaic-tile").each(function(){var i="",t=e(this).attr("class").split(" ");e(t).each(function(){var e=this.match(/^mosaic-(.*)-tile$/);null!==e&&"selected"!==e[1]&&"new"!==e[1]&&"read-only"!==e[1]&&"helper"!==e[1]&&"original"!==e[1]&&(i=e[1])}),t=e(t).filter(function(){switch(this){case"mosaic-new-tile":case"mosaic-helper-tile":case"mosaic-original-tile":case"mosaic-selected-tile":return!1;default:return!0}}).toArray();for(var s,o=0;o<e.mosaic.options.tiles.length;o+=1)for(var c=e.mosaic.options.tiles[o],n=0;n<c.tiles.length;n+=1)c.tiles[n].name===i&&(s=c.tiles[n]);var l;switch(s.tile_type){case"text":a+='          <div class="'+t.join(" ")+'">\n',a+='          <div class="mosaic-tile-content">\n',a+=e(this).children(".mosaic-tile-content").html().replace(/^\s+|\s+$/g,"")+"\n",a+="          </div>\n",a+="          </div>\n";break;case"app":if(a+='          <div class="'+t.join(" ")+'">\n',a+='          <div class="mosaic-tile-content">\n',l=e(this).find(".tileUrl").html(),null===l)break;l=l.replace(e.mosaic.options.context_url,"./"),l=l.replace(/^\.\/\//,"./"),a+='          <div data-tile="'+l+'"></div>\n',a+="          </div>\n",a+="          </div>\n";break;case"field":a+='          <div class="'+t.join(" ")+'">\n',a+='          <div class="mosaic-tile-content">\n',l="./@@plone.app.standardtiles.field?field="+i,a+='          <div data-tile="'+l+'"></div>\n',a+="          </div>\n",a+="          </div>\n",e.mosaic.saveTileValueToForm(i,s)}}),a+="        </div>\n"}),a+="      </div>\n")}),a+="    </div>\n"}),a+="  </body>\n",i='<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">\n<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en" lang="en" data-layout="'+e.mosaic.options.layout+'">\n',i+=a,i+="</html>\n"}}),define("mosaic.toolbar",["jquery","mosaic.layout"],function(e){"use strict";function i(i,a){i.append(void 0!==typeof a.menu&&a.menu?a.icon?e(document.createElement("label")).addClass("mosaic-icon-menu mosaic-icon-menu-"+a.name.replace(/_/g,"-")+" mosaic-icon").html(a.label).attr("title",a.label).append(e(document.createElement("select")).addClass("mosaic-menu-"+a.name.replace(/_/g,"-")).data("action",a.action).change(function(){e(this).mosaicExecAction()}).each(function(){var i,t,s;for(i in a.items)if(void 0!==a.items[i].items){e(this).append(e(document.createElement("optgroup")).addClass("mosaic-option-group mosaic-option-group-"+a.items[i].value.replace(/_/g,"-").replace(/\//g,"-")).attr("label",a.items[i].label)),t=e(this).find(".mosaic-option-group-"+a.items[i].value.replace(/_/g,"-").replace(/\//g,"-"));for(s in a.items[i].items)t.append(e(document.createElement("option")).attr("value",a.items[i].items[s].value).addClass("mosaic-option mosaic-option-"+a.items[i].items[s].value.replace(/\//g,"-")).html(a.items[i].items[s].label))}else e(this).append(e(document.createElement("option")).attr("value",a.items[i].value).addClass("mosaic-option mosaic-option-"+a.items[i].value.replace(/\//g,"-")).html(a.items[i].label))})):e(document.createElement("select")).addClass("mosaic-menu mosaic-menu-"+a.name.replace(/_/g,"-")).data("action",a.action).change(function(){e(this).mosaicExecAction()}).each(function(){var i,t,s;for(i=0;i<a.items.length;i+=1)if(void 0!==a.items[i].items){e(this).append(e(document.createElement("optgroup")).addClass("mosaic-option-group mosaic-option-group-"+a.items[i].value.replace(/_/g,"-").replace(/\//g,"-")).attr("label",a.items[i].label)),t=e(this).find(".mosaic-option-group-"+a.items[i].value.replace(/_/g,"-").replace(/\//g,"-"));for(s in a.items[i].items)t.append(e(document.createElement("option")).attr("value",a.items[i].items[s].value).addClass("mosaic-option mosaic-option-"+a.items[i].items[s].value.replace(/\//g,"-")).html(a.items[i].items[s].label))}else e(this).append(e(document.createElement("option")).attr("value",a.items[i].value).addClass("mosaic-option mosaic-option-"+a.items[i].value.replace(/\//g,"-")).html(a.items[i].label))}):e(document.createElement("button")).addClass("mosaic-button mosaic-button-"+a.name.replace(/_/g,"-")+(a.icon?" mosaic-icon":"")).html(a.label).attr("title",a.label).attr("type","button").data("action",a.action).mousedown(function(){e(this).mosaicExecAction()}))}"undefined"==typeof e.mosaic&&(e.mosaic={}),e.fn.mosaicToolbar=function(){return this.each(function(){var a,t,s,o,c,n,l,r,d,m,p,h,u,f;a=e(this),a.html(""),a.append(e(document.createElement("div")).addClass("mosaic-inline-toolbar")),a=a.children(".mosaic-inline-toolbar"),a.append(e(document.createElement("div")).addClass("mosaic-toolbar-content")),t=a.children(".mosaic-toolbar-content"),s={},t.append(e(document.createElement("div")).addClass("mosaic-toolbar-primary-functions")),s.primary_actions=t.children(".mosaic-toolbar-primary-functions"),t.append(e(document.createElement("div")).addClass("mosaic-toolbar-secondary-functions")),s.secondary_actions=t.children(".mosaic-toolbar-secondary-functions");for(o in s)for(c=0;c<e.mosaic.options[o].length;c+=1)if(void 0===e.mosaic.options[o][c].actions)i(s[o],e.mosaic.options[o][c]);else for(n=e.mosaic.options[o][c],s[o].append(e(document.createElement("fieldset")).addClass("mosaic-button-group mosaic-button-group-"+e.mosaic.options[o][c].name.replace(/_/g,"-"))),l=s[o].children(".mosaic-button-group-"+e.mosaic.options[o][c].name.replace(/_/g,"-")),r=0;r<n.actions.length;r+=1)i(l,n.actions[r]);if(void 0!==e.mosaic.options.formats)for(c=0;c<e.mosaic.options.formats.length;c+=1){for(n=e.mosaic.options.formats[c],s.primary_actions.append(e(document.createElement("fieldset")).addClass("mosaic-button-group mosaic-button-group-"+n.name.replace(/_/g,"-"))),l=s.primary_actions.children(".mosaic-button-group-"+n.name.replace(/_/g,"-")),r=0;r<n.actions.length;r+=1)n.actions[r].favorite&&i(l,n.actions[r]);0===l.children().length&&l.remove()}if(void 0!==e.mosaic.options.tiles)for(d=s.secondary_actions.find(".mosaic-menu-insert"),c=0;c<e.mosaic.options.tiles.length;c+=1){for(n=e.mosaic.options.tiles[c],d.append(e(document.createElement("optgroup")).addClass("mosaic-option-group mosaic-option-group-"+n.name.replace(/_/g,"-")).attr("label",n.label)),l=s.secondary_actions.find(".mosaic-option-group-"+n.name.replace(/_/g,"-")),r=0;r<n.tiles.length;r+=1)m=n.tiles[r],l.append(e(document.createElement("option")).addClass("mosaic-option mosaic-option-"+m.name.replace(/_/g,"-")).attr("value",m.name).html(m.label));0===l.children().length&&l.remove()}if(void 0!==e.mosaic.options.formats)for(p=s.secondary_actions.find(".mosaic-menu-format"),c=0;c<e.mosaic.options.formats.length;c+=1){for(n=e.mosaic.options.formats[c],p.append(e(document.createElement("optgroup")).addClass("mosaic-option-group mosaic-option-group-"+n.name.replace(/_/g,"-")).attr("label",n.label)),l=s.secondary_actions.find(".mosaic-option-group-"+n.name.replace(/_/g,"-")),r=0;r<n.actions.length;r+=1)h=n.actions[r],h.favorite===!1&&l.append(e(document.createElement("option")).addClass("mosaic-option mosaic-option-"+h.name.replace(/_/g,"-")).attr("value",h.name).html(h.label).data("action",h.action));0===l.children().length&&l.remove()}u=function(){var i;parseInt(e(window).scrollTop(),10)>parseInt(a.parent().offset().top,10)?a.hasClass("mosaic-inline-toolbar")&&(i=a.offset().left,a.width(a.width()).css({left:i,"margin-left":"0px"}).removeClass("mosaic-inline-toolbar").addClass("mosaic-external-toolbar").parent().height(a.height())):a.hasClass("mosaic-external-toolbar")&&a.css({width:"",left:"","margin-left":""}).removeClass("mosaic-external-toolbar").addClass("mosaic-inline-toolbar").parent().css("height","")},e(window).bind("scroll",u),f=function(){var i,a,t,s,o,c,n,l;for(e.mosaic.disableEditHtmlSource(),i=e(this),a="",t=e(".mosaic-selected-tile",e.mosaic.document),t.length>0&&(s=t.attr("class").split(" "),e(s).each(function(){var e=this.match(/^mosaic-(.*)-tile$/);null!==e&&"selected"!==e[1]&&"new"!==e[1]&&"read-only"!==e[1]&&"helper"!==e[1]&&"original"!==e[1]&&(a=e[1])})),o=e.mosaic.options.default_available_actions,c=0;c<e.mosaic.options.tiles.length;c+=1)for(n=e.mosaic.options.tiles[c],l=0;l<n.tiles.length;l+=1)n.tiles[l].name===a&&(o=o.concat(n.tiles[l].available_actions));i.find(".mosaic-option-group").show(),i.find(".mosaic-button").hide(),i.find(".mosaic-menu").hide(),i.find(".mosaic-icon-menu").hide(),i.find(".mosaic-menu-format").find(".mosaic-option").hide().attr("disabled","disabled"),e(i.find(".mosaic-menu-format").find(".mosaic-option").get(0)).show().removeAttr("disabled"),e(o).each(function(e,a){i.find(".mosaic-button-"+a).show(),i.find(".mosaic-icon-menu-"+a).show(),i.find(".mosaic-menu-"+a).show(),i.find(".mosaic-option-"+a).show().removeAttr("disabled")}),i.find(".mosaic-menu-insert").children(".mosaic-option-group-fields").children().each(function(){0===e.mosaic.options.panels.find(".mosaic-"+e(this).attr("value")+"-tile").length?e(this).show().removeAttr("disabled"):e(this).hide().attr("disabled","disabled")}),i.find(".mosaic-option-group").each(function(){0===e(this).children(":enabled").length&&e(this).hide()}),e(".mosaic-menu, .mosaic-icon-menu",e.mosaic.document).each(function(){1===e(this).find(".mosaic-option:enabled").length&&e(this).hide()})},e(this).bind("selectedtilechange",f),e(this).trigger("selectedtilechange"),e(".mosaic-menu").each(function(){e(this).select2({width:"style",dropdownCssClass:"mosaic-dropdown mosaic-dropdown-"+e(this).data("action"),dropdownAutoWidth:!0,minimumResultsForSearch:99})});var g=(new Date).getTime();e(this).on("selectedtilechange",function(){e.mosaic.overlay.app||(new Date).getTime()-g>2e3&&(e("#form-widgets-ILayoutAware-content, [name='form.widgets.ILayoutAware.content']").val(e.mosaic.getPageContent()).blur(),g=(new Date).getTime())})})}}),define("mosaic.actions",["jquery","mockup-patterns-modal"],function(e,i){"use strict";"undefined"==typeof e.mosaic&&(e.mosaic={}),e.mosaic.actionManager={actions:[],shortcuts:[]},e.mosaic.registerAction=function(i,a){a=e.extend({exec:function(){},shortcut:{ctrl:!1,alt:!1,shift:!1,key:""},visible:function(){return!0},undoable:!1},a),e.mosaic.actionManager.actions[i]=a,""!==a.shortcut.key&&(a.shortcut.charCode=a.shortcut.key.toUpperCase().charCodeAt(0),a.shortcut.action=i,e.mosaic.actionManager.shortcuts.push(a.shortcut))},e.fn.mosaicExecAction=function(){return this.each(function(){if(""!==e(this).data("action")){var i=e.mosaic.actionManager;i.actions[e(this).data("action")].exec(this),i.actions[e(this).data("action")].undoable&&e.mosaic.undo.snapshot()}})},e.mosaic.fixWebkitSpan=function(){var i=e(".Apple-style-span",e.mosaic.document);i.after(i.html()),i.remove()},e.mosaic.getPrefixedClassName=function(e){return e.indexOf("-")>-1?"mosaic-"+e:"mosaic"+e.charAt(0).toUpperCase()+e.slice(1)},e.mosaic.initActions=function(){e.mosaic.registerAction("apply-format",{exec:function(){arguments.length>0&&arguments[0].value&&e.mosaic.editor.applyFormat(arguments[0].value)}}),e.mosaic.registerAction("tile-toggle-class",{exec:function(){var i;arguments.length>0&&arguments[0].value&&(i=e.mosaic.getPrefixedClassName(arguments[0].value),e(".mosaic-selected-tile",e.mosaic.document).toggleClass(i))}}),e.mosaic.registerAction("tile-remove-format",{exec:function(){var i,a,t,s,o;for(i=0;i<e.mosaic.options.formats.length;i++)for(t=e.mosaic.options.formats[i],a=0;a<t.actions.length;a++)s=t.actions[a],"tile"===s.category&&(o=e.mosaic.getPrefixedClassName(s.name),e(".mosaic-selected-tile",e.mosaic.document).removeClass(o))}}),e.mosaic.registerAction("row-toggle-class",{exec:function(){var i;arguments.length>0&&arguments[0].value&&(i=e.mosaic.getPrefixedClassName(arguments[0].value),e(".mosaic-selected-tile",e.mosaic.document).parents(".mosaic-grid-row").first().toggleClass(i))}}),e.mosaic.registerAction("row-remove-format",{exec:function(){var i,a,t,s,o;for(i=0;i<e.mosaic.options.formats.length;i++)for(t=e.mosaic.options.formats[i],a=0;a<t.actions.length;a++)s=t.actions[a],"row"===s.category&&(o=e.mosaic.getPrefixedClassName(s.name),e(".mosaic-selected-tile",e.mosaic.document).parents(".mosaic-grid-row").first().removeClass(o))}}),e.mosaic.registerAction("strong",{exec:function(){e.mosaic.editor.applyFormat("strong")},shortcut:{ctrl:!0,alt:!1,shift:!1,key:"b"}}),e.mosaic.registerAction("em",{exec:function(){e.mosaic.editor.applyFormat("em")}}),e.mosaic.registerAction("ul",{exec:function(){e.mosaic.execCommand("InsertUnorderedList")}}),e.mosaic.registerAction("ol",{exec:function(){e.mosaic.execCommand("InsertOrderedList")}}),e.mosaic.registerAction("undo",{exec:function(){e.mosaic.execCommand("Undo")}}),e.mosaic.registerAction("redo",{exec:function(){e.mosaic.execCommand("Redo")}}),e.mosaic.registerAction("paragraph",{exec:function(){e.mosaic.editor.applyFormat("p")}}),e.mosaic.registerAction("heading",{exec:function(){e.mosaic.editor.applyFormat("h2")}}),e.mosaic.registerAction("subheading",{exec:function(){e.mosaic.editor.applyFormat("h3")}}),e.mosaic.registerAction("discreet",{exec:function(){e.mosaic.editor.applyFormat("discreet")}}),e.mosaic.registerAction("literal",{exec:function(){e.mosaic.editor.applyFormat("pre")}}),e.mosaic.registerAction("quote",{exec:function(){e.mosaic.editor.applyFormat("pullquote")}}),e.mosaic.registerAction("callout",{exec:function(){e.mosaic.editor.applyFormat("callout")}}),e.mosaic.registerAction("highlight",{exec:function(){e.mosaic.editor.applyFormat("highlight")}}),e.mosaic.registerAction("sub",{exec:function(){e.mosaic.editor.applyFormat("sub")}}),e.mosaic.registerAction("sup",{exec:function(){e.mosaic.editor.applyFormat("sup")}}),e.mosaic.registerAction("remove-format",{exec:function(){e.mosaic.editor.applyFormat("removeformat")}}),e.mosaic.registerAction("pagebreak",{exec:function(){e.mosaic.editor.applyFormat("pagebreak")}}),e.mosaic.registerAction("justify-left",{exec:function(){e.mosaic.editor.applyFormat("justify-left")}}),e.mosaic.registerAction("justify-center",{exec:function(){e.mosaic.editor.applyFormat("justify-center")}}),e.mosaic.registerAction("justify-right",{exec:function(){e.mosaic.editor.applyFormat("justify-right")}}),e.mosaic.registerAction("justify-justify",{exec:function(){e.mosaic.editor.applyFormat("justify-justify")}}),e.mosaic.registerAction("tile-align-block",{exec:function(){e(".mosaic-selected-tile",e.mosaic.document).removeClass("mosaic-tile-align-right").removeClass("mosaic-tile-align-left")},shortcut:{ctrl:!0,alt:!1,shift:!0,key:"b"}}),e.mosaic.registerAction("tile-align-left",{exec:function(){e(".mosaic-selected-tile",e.mosaic.document).removeClass("mosaic-tile-align-right").addClass("mosaic-tile-align-left")},shortcut:{ctrl:!0,alt:!1,shift:!0,key:"l"}}),e.mosaic.registerAction("tile-align-right",{exec:function(){e(".mosaic-selected-tile",e.mosaic.document).removeClass("mosaic-tile-align-left").addClass("mosaic-tile-align-right")},shortcut:{ctrl:!0,alt:!1,shift:!0,key:"r"}}),e.mosaic.registerAction("save",{exec:function(){e("#form-widgets-ILayoutAware-content, [name='form.widgets.ILayoutAware.content']").val(e.mosaic.getPageContent()),e("#form-buttons-save").click()},shortcut:{ctrl:!0,alt:!1,shift:!1,key:"s"}}),e.mosaic.registerAction("cancel",{exec:function(){e("#form-buttons-cancel").click()}}),e.mosaic.registerAction("html",{exec:function(){var i,a,t;i=e(".mosaic-selected-tile",e.mosaic.document).children(".mosaic-tile-content"),0===i.find(".mosaic-rich-text-textarea").length&&(a=i.html(),t=i.height(),i.empty(),i.prepend(e(e.mosaic.document.createElement("textarea")).addClass("mosaic-rich-text-textarea").html(e.trim(a)).height(t)))}}),e.mosaic.registerAction("undo",{exec:function(){e.mosaic.undo.undo()}}),e.mosaic.registerAction("redo",{exec:function(){e.mosaic.undo.redo()}}),e.mosaic.registerAction("properties",{exec:function(){e.mosaic.overlay.open("all")}}),e.mosaic.registerAction("page-layout",{exec:function(){var a=new i(e(".mosaic-original-content"),{title:"Layout options",content:"#fieldset-layout"});a.on("show",function(){a.$modal.removeClass("mosaic-blur").find("#formfield-form-widgets-ILayoutAware-content").remove(),a.$el.find("select").each(function(){var i=e(this).val(),t=e(this).attr("id");a.$modal.find("#"+t).val(i)})}),a.on("hide",function(){a.$modal.find("select").each(function(){var i=e(this).val(),t=e(this).attr("id");a.$el.find("#"+t).val(i)})}),a.show()}}),e.mosaic.registerAction("add-tile",{exec:function(){var a=new i(e(".mosaic-toolbar"),{ajaxUrl:e.mosaic.options.context_url+"/@@add-tile?form.button.Create=Create"});a.show()}}),e.mosaic.registerAction("format",{exec:function(i){e(i).find("[value="+e(i).val()+"]").mosaicExecAction(),e(i).select2("val","none")}}),e.mosaic.registerAction("insert",{exec:function(a){var t,s,o,c,n;if("none"===e(a).val())return!1;for(o=e(a).val(),e(".mosaic-selected-tile",e.mosaic.document).removeClass("mosaic-selected-tile").children(".mosaic-tile-content").blur(),e.mosaic.options.panels.trigger("selectedtilechange"),c=0;c<e.mosaic.options.tiles.length;c+=1)for(s=e.mosaic.options.tiles[c],n=0;n<s.tiles.length;n+=1)s.tiles[n].name===o&&(t=s.tiles[n]);return"app"===t.tile_type?e.ajax({type:"GET",url:e.mosaic.options.context_url+"/@@add-tile?tiletype="+o+"&form.button.Create=Create",success:function(a){var t,s,c,n;t=e(a),s=t.find("form").attr("action"),c=t.find('[name="_authenticator"]').val(),n=function(a){e.mosaic.overlay.app=new i(e(".mosaic-toolbar"),{html:a,loadLinksWithinModal:!0,buttons:'.formControls > input[type="submit"], .actionButtons > input[type="submit"]'}),e.mosaic.overlay.app.$el.off("after-render"),e.mosaic.overlay.app.on("after-render",function(){e('input[name*="cancel"]',e.mosaic.overlay.app.$modal).off("click").on("click",function(){e.mosaic.overlay.app.hide(),e.mosaic.overlay.app=null})}),e.mosaic.overlay.app.show(),e.mosaic.overlay.app.$el.off("formActionSuccess"),e.mosaic.overlay.app.on("formActionSuccess",function(i,a,t,s){var c=s.getResponseHeader("X-Tile-Url");c&&(e.mosaic.addAppTileHTML(o,a,c),e.mosaic.overlay.app.hide(),e.mosaic.overlay.app=null)})},e("form .required",t).filter(function(){return 0==e(this).parents(".field").first().find("input, select, textarea").not('[type="hidden"]').last().val().length}).length>0?n(a):s&&e("form",t).ajaxSubmit({type:"POST",url:s,data:{"buttons.save":"Save",_authenticator:c},success:function(i,a,t){var s=t.getResponseHeader("X-Tile-Url");s?e.mosaic.addAppTileHTML(o,i,s):n(i)}})}}):e.mosaic.addTile(o,e.mosaic.getDefaultValue(t)),e(a).select2("val","none"),!0}}),e(document).keypress(function(i){var a="";return e(e.mosaic.actionManager.shortcuts).each(function(){i.ctrlKey!==this.ctrl&&(-1===navigator.userAgent.toLowerCase().indexOf("macintosh")||i.metaKey!==this.ctrl)||i.altKey!==this.alt&&void 0!==i.altKey||i.shiftKey!==this.shift||!i.charCode||String.fromCharCode(i.charCode).toUpperCase().charCodeAt(0)!==this.charCode||(a=this.action)}),""!==a?(e.mosaic.actionManager.actions[a].exec(),e.mosaic.actionManager.actions[a].undoable&&e.mosaic.undo.snapshot(),!1):!0})}}),define("mosaic.core",["jquery","mosaic.toolbar","mosaic.layout","mosaic.actions"],function(e){"use strict";"undefined"==typeof e.mosaic&&(e.mosaic={}),e.mosaic.loaded=!1,e.mosaic.nrOfTiles=0,e.mosaic.tileInitCount=0,e.mosaic.initialized=function(){e.mosaic.loaded||(e.mosaic.loaded=!0,e.mosaic.undo.snapshot())},e.mosaic.init=function(i){i=e.extend({url:window.document.location.href,type:"",ignore_context:!1},i),e.mosaic.document=window.document;var a;e.mosaic.initActions(),a=i.url.match(/^([\w#!:.?+=&%@!\-\/]+)\/edit$/),a&&(i.url=a[1]),a=i.url.match(/^([\w#:.?=%@!\-\/]+)\/\+\+add\+\+([\w#!:.?+=&%@!\-\/]+)$/),a&&(i.url=a[1],i.type=a[2],i.ignore_context=!0);var t;e.mosaic.options=i.data,e.mosaic.options.url=i.url,e.mosaic.options.ignore_context=i.ignore_context,e.mosaic.options.tileheadelements=[],t=e('[name="form.widgets.ILayoutAware.content"]').val(),""!==t&&(t=e.mosaic.getDomTreeFromHtml(t),e.mosaic.options.layout=t.attr("data-layout"),e("[data-panel] [data-panel]",e.mosaic.document).removeAttr("data-panel"),t.find("[data-panel]").each(function(){var i,a=e(this).attr("data-panel"),s=e("[data-panel="+a+"]",e.mosaic.document);"content"===a&&0===s.length&&e("#"+a,e.mosaic.document).each(function(){s=e(this),s.attr("data-panel",a)}),"content"===a?(i=s.attr("id"),s.removeAttr("data-panel").removeAttr("id").addClass("mosaic-original-content").hide(),s.before(e(document.createElement("div")).attr("id",i).addClass("mosaic-panel").attr("data-panel","content").html(t.find("[data-panel="+a+"]").html()))):(s.addClass("mosaic-panel"),s.html(t.find("[data-panel="+a+"]").html()))}),e("[data-panel]",e.mosaic.document).each(function(){e(this).hasClass("mosaic-panel")||(e(this).addClass("mosaic-panel"),e(this).children().wrap(e('<div class="mosaic-grid-row"><div class="mosaic-grid-cell mosaic-width-full mosaic-position-leftmost"><div class="movable removable mosaic-tile mosaic-text-tile"><div class="mosaic-tile-content"></div></div></div></div>')))}),e.mosaic.options.panels=e(".mosaic-panel",e.mosaic.document),e.mosaic.nrOfTiles=e.mosaic.options.panels.find("[data-tile]").size(),e.mosaic.options.panels.find("[data-tile]").each(function(){var i,a,t,s,o,c,n,l,r,d,m,p,h,u,f;for(i=e(e.mosaic.document).find("head > base").attr("href"),a=e(this).attr("data-tile"),t=e(this).parent(),s="",o=t.parents(".mosaic-tile").attr("class").split(" "),e(o).each(function(){var e;e=this.match(/^mosaic-([\w.\-]+)-tile$/),null!==e&&"selected"!==e[1]&&"new"!==e[1]&&"read-only"!==e[1]&&"helper"!==e[1]&&"original"!==e[1]&&(s=e[1])}),l=0;l<e.mosaic.options.tiles.length;l+=1)for(r=e.mosaic.options.tiles[l],d=0;d<r.tiles.length;d+=1){if("field"===r.tiles[d].tile_type){var g=r.tiles[d].widget.split(".");switch(g=g[g.length-1]){case"TextWidget":case"TextFieldWidget":case"TextAreaWidget":case"TextAreaFieldWidget":case"TextLinesWidget":case"TextLinesFieldWidget":case"WysiwygWidget":case"WysiwygFieldWidget":case"RichTextWidget":case"RichTextFieldWidget":r.tiles[d].settings=!1;break;default:r.tiles[d].settings=!0}}r.tiles[d].name===s&&(n=r.tiles[d])}if(n&&"field"===n.tile_type){switch(m="","IDublinCore-title"===n.name?(u='<h1 class="documentFirstHeading">',f="</h1>"):"IDublinCore-description"===n.name?(u='<p class="documentDescription">',f="</p>"):(u="<div>",f="</div>"),n.widget){case"z3c.form.browser.text.TextWidget":case"z3c.form.browser.text.TextFieldWidget":m=u+e("#"+n.id).find("input").attr("value")+f;break;case"z3c.form.browser.textarea.TextAreaWidget":case"z3c.form.browser.textarea.TextAreaFieldWidget":case"z3c.form.browser.textlines.TextLinesWidget":case"z3c.form.browser.textlines.TextLinesFieldWidget":for(p=e("#"+n.id).find("textarea").val().split("\n"),m+=u,+p[h]+f,h=0;h<p.length;h+=1)m+=p[h]+"<br/>";m+=f;break;case"plone.app.z3cform.widget.RichTextFieldWidget":case"plone.app.z3cform.wysiwyg.widget.WysiwygWidget":case"plone.app.z3cform.wysiwyg.widget.WysiwygFieldWidget":case"plone.app.widgets.dx.RichTextWidget":m=e("#"+n.id).find("textarea").val();break;default:m='<div class="discreet">Placeholder for field:<br/><b>'+n.label+"</b></div>"}t.html(m)}else n&&(c=i?[i,a].join("/").replace(/\/+\.\//g,"/"):a,e.ajax({type:"GET",url:c,success:function(i){i=e.mosaic.getDomTreeFromHtml(i),e.mosaic.addHeadTags(a,i),t.html('<p class="hiddenStructure tileUrl">'+a.replace(/&/gim,"&amp;")+"</p>"+i.find(".temp_body_tag").html()),e.mosaic.tileInitCount+=1,e.mosaic.tileInitCount>=e.mosaic.nrOfTiles&&e.mosaic.initialized()}}))}),e(".mosaic-original-content",e.mosaic.document).mosaicOverlay(),e("body").prepend(e(document.createElement("div")).addClass("mosaic-toolbar")),e.mosaic.options.toolbar=e(".mosaic-toolbar"),e.mosaic.options.url=i.url,e.mosaic.options.toolbar.mosaicToolbar(),e.mosaic.options.panels.mosaicLayout(),e("*",e.mosaic.document).each(function(){var i;i=e(this),"block"===i.css("display")&&(i.hasClass("mosaic-panel")||i.hasClass("mosaic-toolbar")||i.hasClass("mosaic-notifications")||"edit-zone"===i.attr("id")||0===i.parents(".mosaic-panel, .mosaic-toolbar").length&&0===i.find(".mosaic-panel, .mosaic-toolbar").length&&0!==i.parent().find(".mosaic-panel, .mosaic-toolbar").length&&i.addClass("mosaic-blur"))}),e.mosaic.undo.init(),e("body").addClass("mosaic-enabled"))},e.mosaic.getDomTreeFromHtml=function(i){return i=i.replace(/<!DOCTYPE[\w\s\- .\/\":]+>/,""),i=i.replace(/<html>/,'<div class="temp_html_tag">'),i=i.replace(/<\/html>/,"</div>"),i=i.replace(/<html\s/,'<div class="temp_html_tag" '),i=i.replace(/<\/html\s/,"</div "),i=i.replace(/<head>/,'<div class="temp_head_tag">'),i=i.replace(/<\/head>/,"</div>"),i=i.replace(/<head\s/,'<div class="temp_head_tag" '),i=i.replace(/<\/head\s/,"</div "),i=i.replace(/<body>/,'<div class="temp_body_tag">'),i=i.replace(/<\/body>/,"</div>"),i=i.replace(/<body\s/,'<div class="temp_body_tag" '),i=i.replace(/<\/body\s/,"</div "),e(e(i)[0])},e.mosaic.removeHeadTags=function(i){var a,t,s,o;for(i=i.split("?")[0],i=i.split("@@"),a=i[1].split("/"),i=i[0]+"@@delete-tile?type="+a[0]+"&id="+a[1]+"&confirm=true",t=a[0].replace(/\./g,"-")+"-"+a[1],s=e.mosaic.options.tileheadelements[t],o=0;o<s.length;o+=1)e(s[o],e.mosaic.document).remove();e.mosaic.options.tileheadelements[t]=[]},e.mosaic.addHeadTags=function(i,a){var t,s;i=i.split("?")[0],i=i.split("@@"),t=i[1].split("/"),s=t[0].replace(/\./g,"-")+"-"+t[1],e.mosaic.options.tileheadelements[s]=[],a.find(".temp_head_tag").children().each(function(){e.mosaic.options.tileheadelements[s].push(this),e("head",e.mosaic.document).append(this)})}}),define("mosaic.editor",["jquery","tinymce"],function(e,i){"use strict";"undefined"==typeof e.mosaic&&(e.mosaic={}),e.mosaic.editor={},e.fn.mosaicEditor=function(){var a;a=e(this);for(var t=1+Math.floor(1e5*Math.random());e("#mosaic-rich-text-init-"+t,e.mosaic.document).length>0;)t=1+Math.floor(1e5*Math.random());e(this).attr("id","mosaic-rich-text-init-"+t),i.init({selector:"#mosaic-rich-text-init-"+t,theme:"modern",inline:!0,schema:"html5",add_unload_trigger:!1,toolbar:!1,statusbar:!1,menubar:!1,fixed_toolbar_container:null,setup:function(e){var i=function(){0===a.text().replace(/^\s+|\s+$/g,"").length?a.addClass("mosaic-tile-content-empty"):a.removeClass("mosaic-tile-content-empty")};e.on("change",i),i()},formats:{strong:{inline:"strong"},em:{inline:"em"},h2:{block:"h2",remove:"all"},h3:{block:"h3",remove:"all"},p:{block:"p",remove:"all"},sub:{inline:"sub",remove:"all"},sup:{inline:"sup",remove:"all"},discreet:{block:"p",attributes:{"class":"discreet"},remove:"all"},pre:{block:"pre",remove:"all"},pullquote:{block:"q",attributes:{"class":"pullquote"},remove:"all"},callout:{block:"p",attributes:{"class":"callout"},remove:"all"},highlight:{inline:"span",attributes:{"class":"visualHighlight"},remove:"all"},pagebreak:{block:"p",attributes:{"class":"pagebreak"},remove:"all"},"justify-left":{selector:"p,h2,h3,pre,q",attributes:{"class":"justify-left"},remove:"all"},"justify-center":{selector:"p,h2,h3,pre,q",attributes:{"class":"justify-center"},remove:"all"},"justify-right":{selector:"p,h2,h3,pre,q",attributes:{"class":"justify-right"},remove:"all"},"justify-justify":{selector:"p,h2,h3,pre,q",attributes:{"class":"justify-justify"},remove:"all"}}}),i.get("mosaic-rich-text-init-"+t).on("focus",function(i){i.target.id&&e("#"+i.target.id).parents(".mosaic-tile").first().mosaicSelectTile()}),a.addClass("mosaic-rich-text")},e.mosaic.execCommand=function(e,a,t){i.activeEditor&&i.activeEditor.execCommand(e,a,t)},e.mosaic.editor.applyFormat=function(e){i.activeEditor&&tinyMCE.activeEditor.formatter.apply(e)},e.mosaic.editor.registerFormat=function(e,a){i.activeEditor&&i.activeEditor.formatter.register(e,a)}}),define("mosaic.overlay",["jquery"],function(e){"use strict";"undefined"==typeof e.mosaic&&(e.mosaic={}),e.mosaic.overlay={},e.fn.mosaicOverlay=function(){return this.each(function(){var i=e(this);i.hide().css({width:"900px",left:(e(window.parent).width()-900)/2}).addClass("mosaic-overlay"),e(document.body,e.mosaic.document).prepend(e(document.createElement("div")).addClass("mosaic-overlay-blocker"))})},e.mosaic.overlay.open=function(i,a){var t,s,o,c,n,l,r,d;if(e(".mosaic-overlay").show(),e(".mosaic-overlay-blocker").show(),t=e(".mosaic-overlay").find("form"),0===e(".mosaic-overlay-ok-button").length&&(e(".mosaic-overlay .formControls").children("input").hide(),e(".mosaic-overlay .formControls").append(e(document.createElement("input")).attr({type:"button",value:"Close"}).addClass("button-field context mosaic-overlay-ok-button").click(function(){e.mosaic.overlay.close()})),e(".mosaic-overlay").prepend(e(document.createElement("button")).attr({title:"Close"}).addClass("mosaic-overlay-close").html("&times;").click(function(){e.mosaic.overlay.close()}))),"all"===i){for(s=t.find("nav"),s.removeClass("mosaic-hidden"),t.find("fieldset").children().removeClass("mosaic-hidden"),t.find("fieldset").removeClass("active"),s.find("a").removeClass("active"),t.find("#formfield-form-widgets-ILayoutAware-content").addClass("mosaic-hidden"),t.find("#formfield-form-widgets-ILayoutAware-pageSiteLayout").addClass("mosaic-hidden"),t.find("#formfield-form-widgets-ILayoutAware-sectionSiteLayout").addClass("mosaic-hidden"),t.find("#formfield-form-widgets-IDublinCore-title").addClass("mosaic-hidden"),t.find("#formfield-form-widgets-IDublinCore-description").addClass("mosaic-hidden"),c=0;c<e.mosaic.options.tiles.length;c+=1)"fields"===e.mosaic.options.tiles[c].name&&(o=e.mosaic.options.tiles[c]);for(c=0;c<o.tiles.length;c+=1)l=o.tiles[c],0!==e.mosaic.options.panels.find(".mosaic-"+l.name+"-tile").length&&e(e.mosaic.document.getElementById(l.id)).addClass("mosaic-hidden");
t.find("fieldset").each(function(){0===e(this).children("div:not(.mosaic-hidden)").length&&e("a[href=#fieldsetlegend-"+e(this).attr("id").split("-")[1]+"]").addClass("mosaic-hidden")}),n=s.children(":not(.mosaic-hidden)"),n.eq(0).addClass("active"),t.find("#fieldset-"+n.eq(0).attr("href").split("-")[1]).addClass("active")}else"field"===i&&(r=e("#"+a.id),d=r.parents("fieldset"),t.find("fieldset").hide(),d.show(),d.children().addClass("mosaic-hidden"),r.removeClass("mosaic-hidden"),t.find("nav").addClass("mosaic-hidden"))},e.mosaic.overlay.close=function(){e(".mosaic-overlay").hide(),e(".mosaic-overlay-blocker").hide()}}),define("mosaic.undo",["jquery"],function(e){"use strict";"undefined"==typeof e.mosaic&&(e.mosaic={}),e.mosaic.undo=function(){},e.mosaic.undo.init=function(){function i(i){for(var a=0;a<i.length;a+=1)e("#"+i[a].target,e.mosaic.document).html(i[a].source)}e.mosaic.undo.undoManager=new e.mosaic.undo.UndoManager(10,i)},e.mosaic.undo.snapshot=function(){var i=[];e(".mosaic-panel",e.mosaic.document).each(function(){i.push({target:e(this).attr("id"),source:e(this).html()})}),"undefined"==typeof e.mosaic.undo.undoManager&&e.mosaic.undo.init(),e.mosaic.undo.undoManager.add(i)},e.mosaic.undo.hasInitial=function(){return e.mosaic.undo.undoManager.stack.size()>0?!0:!1},e.mosaic.undo.undo=function(){e.mosaic.undo.undoManager.undo()},e.mosaic.undo.redo=function(){e.mosaic.undo.undoManager.redo()},e.mosaic.undo.Stack=function(e){this.maxsize="undefined"==typeof e?10:e,this.stack=[]},e.mosaic.undo.Stack.prototype.size=function(){return this.stack.length},e.mosaic.undo.Stack.prototype.add=function(e){this.stack.length>=this.maxsize&&this.stack.pop(),this.stack.unshift(e)},e.mosaic.undo.Stack.prototype.get=function(e){return this.stack[e]},e.mosaic.undo.UndoManager=function(i,a,t){this.stack=new e.mosaic.undo.Stack(i),this.pointer=0,this.handler=a,"undefined"!=typeof t&&this.stack.add(t)},e.mosaic.undo.UndoManager.prototype.add=function(e){this.stack.add(e)},e.mosaic.undo.UndoManager.prototype.undo=function(){var e=this.stack.get(this.pointer+1);e&&(this.handler(e),this.pointer+=1)},e.mosaic.undo.UndoManager.prototype.redo=function(){var e=this.stack.get(this.pointer-1);e&&(this.handler(e),this.pointer-=1)}}),define("mosaic.upload",["jquery"],function($){"use strict";"undefined"==typeof $.mosaic&&($.mosaic={}),$.mosaic.initUpload=function(){$(".mosaic-panel",$.mosaic.document).bind("dragover",function(){0===$(".mosaic-panel-dragging",$.mosaic.document).length&&($(".mosaic-selected-tile",$.mosaic.document).removeClass("mosaic-selected-tile").children(".mosaic-tile-content").blur(),$.mosaic.options.toolbar.trigger("selectedtilechange"),$.mosaic.options.panels.mosaicSetResizeHandleLocation(),$.mosaic.addTile("image",'<img src="++resource++plone.app.mosaic.images/files.png" border="0" />'))}),document.addEventListener("drop",function(event){var dt,first,i,files,newtile,file,img,tile,xhr,boundary,data;for(dt=event.dataTransfer,files=dt.files,event.stopPropagation(),event.preventDefault(),$($.mosaic.document).trigger("mousedown"),first=!0,i=0;i<files.length;i+=1)file=files.item(i),0===file.mediaType.indexOf("image")?(first?(img=$(".mosaic-selected-tile",$.mosaic.document).children(".mosaic-tile-content").children("img"),tile=$(".mosaic-selected-tile",$.mosaic.document),first=!1):(newtile=$($.mosaic.document.createElement("div")).addClass("movable removable mosaic-tile mosaic-image-tile").append($($.mosaic.document.createElement("div")).addClass("mosaic-tile-content").append($($.mosaic.document.createElement("img")).attr("border",0))),$(".mosaic-selected-tile",$.mosaic.document).after(newtile),newtile.mosaicInitTile(),newtile.mosaicAddDrag(),img=newtile.children(".mosaic-tile-content").children("img"),tile=newtile),tile.append($($.mosaic.document.createElement("div")).addClass("mosaic-tile-uploadprogress")),img.get(0).src=file.getAsDataURL(),xhr=new XMLHttpRequest,xhr.upload.log=img,xhr.addEventListener("load",function(event){var response=eval("("+event.target.responseText+")");1===response.status?$.plone.notify({type:"error",title:"Error",message:response.message,sticky:!0}):$(event.target.upload.log).attr({src:response.url,alt:response.title}).parents(".mosaic-tile").children(".mosaic-tile-uploadprogress").fadeOut("slow",function(){$(this).remove()})},!1),xhr.upload.addEventListener("error",function(e){$.plone.notify({type:"error",title:"Error",message:"Error uploading file: "+e,sticky:!0})},!1),boundary="AJAX---------------------------AJAX",xhr.open("POST",$.mosaic.options.url+"/@@mosaic-upload",!0),xhr.setRequestHeader("Content-Type","multipart/form-data; boundary="+boundary),data="--"+boundary+"\r\n",data+="Content-Disposition: form-data; ",data+='name="uploadfile"; ',data+='filename="'+file.fileName+'"\r\n',data+="Content-Type: "+file.mediaType,data+="\r\n\r\n",data+=file.getAsBinary()+"\r\n",data+="--"+boundary+"--\r\n",xhr.sendAsBinary(data)):$.plone.notify({type:"warning",title:"Warning",message:"The filetype of file "+file.fileName+" is unsupported",sticky:!0});first&&$(".mosaic-selected-tile",$.mosaic.document).find(".mosaic-close-icon").trigger("click")},!1)}});
/* Layout Mosaic pattern.
 *
 * Options:
 *
 * Documentation:
 *
 * License:
 *    Copyright (C) 2014 Plone Foundation
 *
 *    This program is free software; you can redistribute it and/or modify it
 *    under the terms of the GNU General Public License as published by the
 *    Free Software Foundation; either version 2 of the License.
 *
 *    This program is distributed in the hope that it will be useful, but
 *    WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General
 *    Public License for more details.
 *
 *    You should have received a copy of the GNU General Public License along
 *    with this program; if not, write to the Free Software Foundation, Inc.,
 *    51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
 */
window.DEBUG = true;
require([
    'jquery',
    'mockup-patterns-base',
    'mosaic.core',
    'mosaic.layout',
    'mosaic.toolbar',
    'mosaic.actions',
    'mosaic.upload',
    'mosaic.editor',
    'mosaic.undo',
    'mosaic.overlay',
], function($, Base) {
    'use strict';

    var Layout = Base.extend({
        name: 'layout',
        trigger: '.pat-layout',
        defaults: {
            attribute: 'class'
        },
        init: function() {
            var self = this;
            self.options.data.$el = self.$el;
            $.mosaic.init({'data': self.options.data});
        }
    });

    return Layout;
});